package cos.workflow.helloworld;

import java.util.List;

import org.jbpm.api.ProcessInstance;
import org.jbpm.api.job.Job;
import org.jbpm.api.task.Task;
import org.jbpm.test.JbpmTestCase;

public class MainTest extends JbpmTestCase {
	 
	 String deploymentId;
	 
	  protected void setUp() throws Exception {
	    super.setUp();
	 
	    deploymentId = repositoryService.createDeployment()
	        .addResourceFromClasspath("hello_world.assignee.jpdl.xml")
	        .deploy();
	  }
	 
	  protected void tearDown() throws Exception {
	    repositoryService.deleteDeploymentCascade(deploymentId);
	 
	    super.tearDown();
	  }
	 
	  public void testTask() {
	        ProcessInstance processInstance = executionService.startProcessInstanceByKey("helloWorld");
	        String pid = processInstance.getId();
	        List<Job> jobs;
	        
	        List < Task > taskList = taskService.findPersonalTasks("admin");
	        Task task = taskList.get(0);
	        taskService.completeTask(task.getId());
	        System.out.println("Task Name : "+task.getName());
	        processInstance = executionService.findProcessInstanceById(pid);
	        assertNotNull(processInstance);
	 
	 
	        taskList = taskService.findPersonalTasks("admin");
	        task = taskList.get(0);
	        System.out.println("Task Name : "+task.getName());
	        taskService.completeTask(task.getId());
	        processInstance = executionService.findProcessInstanceById(pid);
	        assertNotNull(processInstance);

	        taskList = taskService.findPersonalTasks("admin");
	        task = taskList.get(0);
	        System.out.println("Task Name : "+task.getName());
	        taskService.completeTask(task.getId());
	        processInstance = executionService.findProcessInstanceById(pid);
	        assertNotNull(processInstance);


	        taskList = taskService.findPersonalTasks("admin");
	        task = taskList.get(0);
	        System.out.println("Task Name : "+task.getName());
	        taskService.completeTask(task.getId());
	        processInstance = executionService.findProcessInstanceById(pid);
	        assertNotNull(processInstance);

	        taskList = taskService.findPersonalTasks("admin");
	        task = taskList.get(0);
	        System.out.println("Task Name : "+task.getName());
	        taskService.completeTask(task.getId());
	        processInstance = executionService.findProcessInstanceById(pid);
	        assertNotNull(processInstance);

	        jobs = managementService.createJobQuery().list();
	        for(Job job: jobs) {
	        	System.out.println(job.getId());
		        managementService.executeJob(job.getId());
		        jobs = managementService.createJobQuery().list();
	        	System.out.println("Execute Job : "+job.getId());
	        }

	        processInstance = executionService.findProcessInstanceById(pid);
	        assertNull(processInstance);

	  }
	}
